require "defines"

local toplace, info, name = {}

for i,p in pairs(game.itemprototypes) do
	if p.placeresult and p.placeresult.type=="transport-belt" then
		name=p.placeresult.name
		if toplace[name] then
			table.insert(toplace[name],i)
		else
			toplace[name]={i}
		end
	end
end
for e,ls in pairs(toplace) do
	if #ls==1 then
		toplace[e]=ls[1]
	else
		for _,entry in pairs(ls) do
			if entry==e then toplace[e]=e;break end
		end
		toplace[e]=nil
	end
end

function init() info = glob.placedinfo or {} end
game.onsave(function() glob.placedinfo = info end)
game.onload(init)
game.oninit(init)

game.onevent(defines.events.onbuiltentity, function(event)
	local e,p = event.createdentity, event.playerindex
	local rel, d = info[p]
	if not rel then info[p]={};rel=info[p];end
	p=game.getplayer(p)
	if e.type ~= "transport-belt" then rel.prev=nil;return end
	--p.print(serpent.line(rel))
	local prev = rel.prev
	rel.prev=e
	if prev and prev.valid then
		
		d = rel.dir
		if d<0 then
			if d==-8 then
				if prev.position.x==e.position.x and prev.position.y-1==e.position.y then rel.dir=0;return end
			elseif d==-6 then
				if prev.position.x+1==e.position.x and prev.position.y==e.position.y then rel.dir=2;return end
			elseif d==-4 then
				if prev.position.x==e.position.x and prev.position.y+1==e.position.y then rel.dir=4;return end
			elseif d==-2 then
				if prev.position.x-1==e.position.x and prev.position.y==e.position.y then rel.dir=6;return end
			end
			rel.dir=e.direction-8
			return
		end
		if d ~= e.direction then rel.dir=e.direction-8;return end
		local dx,dy= e.position.x-prev.position.x, e.position.y-prev.position.y
		--p.print(dx..dy)
		if dx==0 then
			if dy==-1 then prev.direction=0;rel.pdir=0;return
			elseif dy==1 then prev.direction=4;rel.pdir=4;return
			else rel.dir=e.direction-8;return end
		elseif dy==0 then
			if dx==-1 then prev.direction=6;rel.pdir=6;return
			elseif dx==1 then prev.direction=2;rel.pdir=2;return
			else rel.dir=e.direction-8;return end
		else
			if dx*dx*dy*dy==1 then
				local item, pos = p.cursorstack
				if item then item=item.name else item=toplace[e.name] end
				if item and p.getitemcount(item)>0 then
					if rel.pdir==0 then
						if dy==-1 then
							pos={prev.position.x,prev.position.y-1}
							if dx==-1 then d=6 else d=2 end
						end
					elseif rel.pdir==2 then
						if dx==1 then
							pos={prev.position.x+1,prev.position.y}
							if dy==-1 then d=0 else d=4 end
						end
					elseif rel.pdir==4 then
						if dy==1 then
							pos={prev.position.x,prev.position.y+1}
							if dx==-1 then d=6 else d=2 end
						end
					elseif rel.pdir==6 then
						if dx==-1 then
							pos={prev.position.x-1,prev.position.y}
							if dy==-1 then d=0 else d=4 end
						end
					end
					if pos and game.canplaceentity{name=e.name,position=pos} then
						prev.direction=rel.pdir
						game.createentity{name=e.name,position=pos,direction=d,force=p.force}
						p.removeitem{name=item,count=1}
						rel.pdir=d
						return
					end
				end
			end
		end
	end
	rel.dir=e.direction-8
end)
